Alt account of @Badabinski

Just a sweaty nerd interested in software, home automation, emotional issues, and polite discourse about all of the above.

  • 0 Posts
  • 240 Comments
Joined 2 years ago
cake
Cake day: June 9th, 2024

help-circle
  • I have a friend who is absolutely obsessed with roller coasters, but many parks don’t allow you to wear a body camera (to say nothing of phones, you’re absolutely not allowed to hold a recording device). Like, this guy will ride the same coaster back to back for hours and will absolutely watch a recording. He bought a pair for this one purpose. I would not have bought them and he definitely felt extremely conflicted. I think he keeps them in a case at all times and only wears them when he’s about to get on a ride.

    Basically, he only bought them as an action camera alternative. He doesn’t use any of their creepy social media features.


  • For future reference, you should remove set -euo pipefail and then add manual error handling to all commands which could fail. set -euo pipefail is one of the biggest, most disgusting foot guns in bash (a shit language cursed with many horrible foot guns) and does nothing but mask your problems. If every command has a unique error message, then you can much more easily track down your problems.

    To make things more ergonomic, remove the foot gun and add a die function that accepts an error message and optional exit code and calls it like this:

    echoerr() { echo "$@" 1>&2; }
    
    die() {
      message="$1"; shift
      exit_code="${1:-1}"
      echoerr "$message"
      exit "$exit_code"
    }
    
    fallible_command || die 'shit is so fucked yo'
    

    source: bash was my first language and I’ve been dealing with its bullshit personally and professionally for over 13 years now.












  • I’ll say that given the way OpenAI and Anthropic have hideously overextended themselves (they have over a trillion dollars of financial commitments to companies like Oracle), it’s not impossible that the current crop of American LLM providers do just kinda… poof away. Traditional banks want nothing more to do with them, they’re getting majorly spooked. All that needs to happen is for private credit to lose confidence in them, which is already happening. When they’re out of cash, they’ll be on the hook for an absolute ridiculous amount of money and they’ll probably just get liquidated.

    I’m sure there will be new companies that pop up, but they’re going to have to charge 10x what Anthropic is making enterprise customers pay, since inference likely still isn’t profitable at the price Anthropic is charging.

    I don’t use LLMs as a knowledge base because if the problem is bad enough for me, I’m likely just grepping through kubernetes source code or something. That being said, I don’t necessarily have an issue with folks using an LLM that way as long as they fully understand exactly how bad it is at what it does. You’ll be fine if you lose access to LLMs, and that’s the number one thing in my book. Your friend? Not so much.

    (As a fun bonus to all of this, Oracle is very likely to die if OpenAI can’t meet its commitments. Either way, Larry Ellison will probably stop being a billionaire, since almost all of his wealth is in Oracle stock).


  • The speed and ease at which LLMs allow you to generate code is a bug, not a feature in my opinion. In my org, a group of 3 very junior engineers wrote a 5k line shell script for building k8s clusters according to our business specs and it’s fucking awful. The actual time to get it out the door was short, but now it’s basically impossible to change it without fucking up like 20 different things. The fucking thing will randomly quit because the shit ass LLM thinks set -e is a good thing to use, and it’s full of unused variables everywhere. I had to add a feature to it (which is how I learned of its existence), and I spent a miserable week just reading the entire fucking thing so I could ensure that my change wouldn’t cause an oil refinery in the North Sea to explode due to a butterfly-effect series of bullshit.

    The frustration and toil you feel as a software dev is a feature. If something is making you mad and is taking forever to write, that’s a sign you probably need to change your approach. If you’re using an LLM to write a bunch of boilerplate, why not just eliminate the boilerplate or like, make a factory to spit out a bunch of it or something? Your discomfort is a powerful tool and you are not best served by ignoring it. Those junior devs would have written something much better if they had been forced to experience the true toil and suffering of writing a 5k line shell script.






  • Building a jet doesn’t require over a trillion dollars of capex, and selling jets is profitable. There’s solid evidence that inference isn’t profitable, and the AI labs need inference to be extremely profitable if they’re going to meet their absolutely ludicrous contractual performance targets. Oracle is expecting hundreds of billions of dollars from OpenAI by like 2030. That shit is not happening.


  • The segmented caching request thing is… weird. I worked for a company that developed a caching proxy and it very much did not work that way. Like, random access in a caching system is usually kinda bad and you should try to avoid it. Like, our proxy manually controlled the disk (it wasn’t a mounted filesystem) so it could constantly sweep the head across the disk and cue up reads and writes optimally. This gets much harder when things are fragmented as fuck.

    If the concern was about what would happen with multiple connections for the same cache miss, then the caching proxy should just combine the client-side connections into a single upstream one. You can still cache the first part of the response if your upstream connection gets terminated and then restart it from that point.